//----------------------------------------------
// Yanghai Tsin 
// November 1st, 1997
//----------------------------------------------


#ifndef CMIL_H
#define CMIL_H

#include <mil.h>
#include <windows.h>


class CMil
{
public:
	bool FrameRect(long XStart, long  YStart, long  XEnd,long  YEnd);
	bool TextOut(long x, long y, char* string);
	void SetForegroundColor(DWORD color);
	bool PutBuffer(void* buffer);
	bool GetLatestImage(char* buffer);
	bool SetDisplay(bool bDisplay);
	bool ResetMil(void);
	bool Initialize(bool bColor=TRUE, double dScale=1.0, bool bDisplay=TRUE);
	bool SetColor(bool bColor);
	bool SetScale(double dScale);
	bool GetDisplay(void);
	bool GetColor(void);
	double GetScale(void);
	int GetY(void);
	int GetX(void);
	void Close(void);
	bool ClearDisplayBuffer(void);
	CMil();
	~CMil();
private:
	bool m_bTimerReset;
	double Time;

	MIL_ID MilImageDisplay;
	bool m_bIsMilInitialized;
	long BufferAttributes;
	DWORD m_dColorValue;
	MIL_ID ChildColorBlue;
	MIL_ID ChildColorGreen;
	MIL_ID ChildColorRed;
	bool m_bDisplay;
	double m_dScale;
	bool m_bColor;
	bool GetBuffer(void* buffer, MIL_ID* MilImage);

	long		SizeX;				   // Buffer Size X
	long		SizeY;				   // Buffer Size Y
	long		DigSizeX;			   // Digitizer input width
	long		DigSizeY;			   // Digitizer input heigh
	long		Band;				      // Number of input color bands of the digitizer
	long		NumberOfDigitizer;   // Number of digitizers available on the system

	MIL_ID 	MilApplication; 	   // Application identifier.  
	MIL_ID 	MilSystem;     		// System identifier.       
	MIL_ID 	MilDigitizer;		   // Digitizer identifier.
	MIL_ID 	MilDisplay;

	MIL_ID MilImageGrab;
	//CView* m_pView;
	//CRect MMRect;
};

#endif