#if !defined(AFX_VISCA98DLG_H__9B631211_2582_11D2_882B_00104B750C43__INCLUDED_)
#define AFX_VISCA98DLG_H__9B631211_2582_11D2_882B_00104B750C43__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Visca98Dlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVisca98Dlg dialog

#include "resource.h"
#include "CVisca98.h"

class CVisca98Dlg : public CDialog
{
// Construction
public:
	CVisca98Dlg(CWnd* pParent = NULL);   // standard constructor

	CVisca98 *visca;
	bool	Initialize(CVisca98 *v);

// Dialog Data
	//{{AFX_DATA(CVisca98Dlg)
	enum { IDD = IDD_DIALOG_VISCA };
	CStatic	m_text_focus_stop_label_ctrl;
	CButton	m_frame_focus_stop_ctrl;
	CSpinButtonCtrl	m_spin_zoom_control;
	CStatic	m_focus_near_label_ctrl;
	CButton	m_focus_stop_ctrl;
	CStatic	m_focus_far_label_ctrl;
	CStatic	m_focus_ctrl;
	CStatic	m_zoom_speed_label_ctrl;
	CStatic	m_focus_speed_label_ctrl;
	CStatic	m_focus_speed_ctrl;
	CStatic	m_text_display_label_ctrl;
	CSpinButtonCtrl	m_spin_focus_ctrl;
	CButton	m_frame_display_ctrl;
	CButton	m_time_display_ctrl;
	CButton	m_date_display_ctrl;
	CButton	m_wb_trigger_ctrl;
	CButton	m_time_set_ctrl;
	CButton	m_brightness_reset_cntrl;
	CStatic	m_text_zoom_speed_ctrl;
	CSpinButtonCtrl	m_spin_zoom_speed;
	CSpinButtonCtrl	m_spin_shutter;
	CSpinButtonCtrl	m_spin_iris;
	CSpinButtonCtrl	m_spin_gain;
	CSpinButtonCtrl	m_spin_focus_speed;
	CSpinButtonCtrl	m_spin_brightness;
	CSliderCtrl	m_slider_zoom;
	CSliderCtrl	m_slider_focus;
	int		m_aemode;
	int		m_focus_mode;
	int		m_wbmode;
	CString	m_text_camera_type;
	CString	m_text_focus_speed;
	CString	m_text_gain;
	CString	m_text_iris;
	CString	m_text_shutter;
	CString	m_text_zoom_speed;
	CString	m_text_focus;
	CString	m_text_zoom;
	BOOL	m_allow_error_messages;
	BOOL	m_date_display;
	BOOL	m_debug_packets;
	BOOL	m_time_display;
	//}}AFX_DATA


private:
	int		m_CameraType;
	char	ShutterStr[28][8];
	char	IrisStr[18][7];
	char	GainStr[8][6];
	int		FocusSpeed, ZoomSpeed;
	int		Gain, Iris, Shutter;
	bool	Zooming;
	bool	Focusing;

	void	SetZoomControls();
	void	SetFocusControls();
	void	SetWBControls();
	void	SetTimeControls();
	void	SetDebugControls();
	void	SetAEControls();
	void	UpdateParameters();
	void	UpdateAEParameters();
	void	SetDlgState();
	void	SetZoom(int zoom);
	void	SetFocus(int focus);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVisca98Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CVisca98Dlg)
	afx_msg void OnButtonTimeSet();
	afx_msg void OnButtonWbTrigger();
	afx_msg void OnCheckAllowErrorMessages();
	afx_msg void OnCheckDateDisplay();
	afx_msg void OnCheckDebugPackets();
	afx_msg void OnCheckTimeDisplay();
	afx_msg void OnRadioAemodeAuto();
	afx_msg void OnRadioAemodeBrightness();
	afx_msg void OnRadioAemodeIris();
	afx_msg void OnRadioAemodeManual();
	afx_msg void OnRadioAemodeShutter();
	afx_msg void OnRadioFocusAuto();
	afx_msg void OnRadioManual();
	afx_msg void OnRadioWbmodeAuto();
	afx_msg void OnRadioWbmodeIndoor();
	afx_msg void OnRadioWbmodeOnePush();
	afx_msg void OnRadioWbmodeOutdoor();
	afx_msg void OnDeltaposSpinBrightness(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinFocus(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinFocusSpeed(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinGain(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinIris(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinShutter(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinZoom(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinZoomSpeed(NMHDR* pNMHDR, LRESULT* pResult);
	virtual void OnOK();
	afx_msg void OnButtonBrightnessReset();
	afx_msg void OnButtonUpdate();
	afx_msg void OnButtonFocusStop();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VISCA98DLG_H__9B631211_2582_11D2_882B_00104B750C43__INCLUDED_)
