// DebugWindow.cpp : implementation file
//
// Copyright 1996 David Sarnoff Research Center
// All Rights Reserved
// Shop Order: 38311
// Author: mkl
//
// (#) $Id: debugwindow.cpp,v 1.1 1997/07/30 18:13:20 jeledath Exp $

#include "stdafx.h"
#include "resource.h"
#include "DebugWindow.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebugWindow dialog


CDebugWindow::CDebugWindow(CWnd* pParent /*=NULL*/)
	: CDialog(CDebugWindow::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugWindow)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	bPaused = FALSE;
}


void CDebugWindow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugWindow)
	DDX_Control(pDX, IDOK, m_okBtn);
	DDX_Control(pDX, IDC_LIST1, m_listbox);
	DDX_Control(pDX, IDC_BUTTON_SAVE, m_saveBtn);
//	DDX_Control(pDX, IDC_BUTTON_PRINT, m_printBtn);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_clearBtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebugWindow, CDialog)
	//{{AFX_MSG_MAP(CDebugWindow)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDOK, OnHide)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugWindow message handlers

void CDebugWindow::OnButtonClear() 
{
	m_listbox.ResetContent();
}

void CDebugWindow::OnButtonPrint() 
{
	bPaused = !bPaused;
	
	if (bPaused)
		SetWindowText("Resume");
	else
		SetWindowText("Pause");
}

void CDebugWindow::OnButtonSave() 
{
	CFileDialog fd(FALSE, "*.log", "wgDebug.log", 
				   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_LONGNAMES,
				   NULL, this);
	fd.DoModal();

	CString filename;
	char buf[128];

	filename = fd.GetFileName();
	FILE *fh;

	fh = fopen(filename.GetBuffer(128), "w");
	if (fh)
	{
		
		int cnt = m_listbox.GetCount();
		for (int i=0; i<cnt; i++)
		{
			m_listbox.GetText(i, buf);
			fprintf(fh, "%s\n", buf);
		}
	}	
	fclose(fh);
}

BOOL CDebugWindow::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//MoveWindow(327, 560, 649, 200);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDebugWindow::OnButtonPause() 
{
	bPaused = !bPaused;
	
	if (bPaused)
		m_printBtn.SetWindowText("Resume");
	else
		m_printBtn.SetWindowText("Pause");
}

void CDebugWindow::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	int btnWidth=cx/7;

	if (m_listbox.m_hWnd)
		m_listbox.MoveWindow(10, 10, cx-20, cy-40);
	if (m_clearBtn.m_hWnd)
		m_clearBtn.MoveWindow(10, cy-25, btnWidth, 20);
	if (m_printBtn.m_hWnd)
		m_printBtn.MoveWindow(10+btnWidth, cy-25, btnWidth, 20);
	if (m_saveBtn.m_hWnd)
		m_saveBtn.MoveWindow(10+btnWidth*2, cy-25, btnWidth, 20);
	if (m_okBtn.m_hWnd)
		m_okBtn.MoveWindow(10+btnWidth*3, cy-25, btnWidth, 20);
}

void CDebugWindow::OnHide() 
{
	// TODO: Add your control notification handler code here
	ShowWindow(SW_SHOWMINIMIZED);
}
