// visca98View.cpp : implementation of the CVisca98View class
//

#include "stdafx.h"
#include "visca98.h"

#include "CVisca98.h"
#include "CMil.h"
#include "visca98Doc.h"
#include "visca98View.h"
#include "winprintf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern	void	lookmsg();

/////////////////////////////////////////////////////////////////////////////
// CVisca98View

IMPLEMENT_DYNCREATE(CVisca98View, CView)

BEGIN_MESSAGE_MAP(CVisca98View, CView)
	//{{AFX_MSG_MAP(CVisca98View)
	ON_COMMAND(ID_MIL_END, OnMilEnd)
	ON_UPDATE_COMMAND_UI(ID_MIL_END, OnUpdateMilEnd)
	ON_COMMAND(ID_MIL_START, OnMilStart)
	ON_UPDATE_COMMAND_UI(ID_MIL_START, OnUpdateMilStart)
	ON_COMMAND(ID_VISCA_VISCA_PARAMETERS, OnViscaViscaParameters)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisca98View construction/destruction

CVisca98View::CVisca98View()
{
	// TODO: add construction code here
	wgCreateDebugWindow();
	mil_open = false;
	visca_open = visca.Open("COM2\0");
}

CVisca98View::~CVisca98View()
{
	if (mil_open) mil.Close();
	mil_open = false;
	if (visca_open) visca.Close();
	visca_open = false;
}

BOOL CVisca98View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVisca98View drawing

void CVisca98View::OnDraw(CDC* pDC)
{
	CVisca98Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CVisca98View printing

BOOL CVisca98View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CVisca98View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CVisca98View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CVisca98View diagnostics

#ifdef _DEBUG
void CVisca98View::AssertValid() const
{
	CView::AssertValid();
}

void CVisca98View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CVisca98Doc* CVisca98View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVisca98Doc)));
	return (CVisca98Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVisca98View message handlers

void CVisca98View::OnMilEnd() 
{
	// TODO: Add your command handler code here
	mil_open = false;
	mil.Close();
}

void CVisca98View::OnUpdateMilEnd(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
		pCmdUI->Enable(mil_open);
}

void CVisca98View::OnMilStart() 
{
	char	buff[640*480*3];
	// TODO: Add your command handler code here
	mil_open = mil.Initialize(true, 1.0, true);
	if (!mil_open) return;
	
	while (mil_open) {
		mil.GetLatestImage(buff);
		mil.PutBuffer(buff);
		lookmsg();
	}
}

void CVisca98View::OnUpdateMilStart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
		pCmdUI->Enable(!mil_open);
	
}

void CVisca98View::OnViscaViscaParameters() 
{
	CVisca98Dlg		*dlg = NULL;

	dlg = new CVisca98Dlg();

	dlg->Create(IDD_DIALOG_VISCA, NULL);

	if (!dlg->Initialize(&visca)) {
		wgPrintf("Can't talk to VISCA98");
		delete dlg;
		return;
	}

	dlg->ShowWindow(SW_SHOW);
	dlg->UpdateData(false);

}

void CVisca98View::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	wgPrintf("nChar %c, %d", nChar, nChar);
	switch(nChar) {
	case 'A':
		wgPrintf("Zooming in");
		visca.SetZoomIn(1, 2);
		wgPrintf("Zoomed in");
		wgPrintf("Zoomed to %d", visca.GetZoom(1));
		break;
	case 'Z':
		wgPrintf("Zooming out");
		visca.SetZoomOut(1, 7);
		wgPrintf("Zoomed out");
		wgPrintf("Zoomed to %d", visca.GetZoom(1));
		break;
	case 'Q':
		wgPrintf("Zooming stop");
		visca.SetZoomStop(1);
		wgPrintf("Zoomed stop");
		wgPrintf("Zoomed to %d", visca.GetZoom(1));
		break;
	case '1':
		wgPrintf("Zoom to 555");
		visca.SetZoom(1, 1022, false);
		wgPrintf("Zoomed to %d", visca.GetZoom(1));
		break;
	case 'X':
		wgPrintf("Focus mode Auto");
		visca.SetFocusMode(1, FOCUS_MODE_AUTO);
		wgPrintf("Focus mode %d", visca.GetFocusMode(1));
		break;
	case 'S':
		wgPrintf("Focus mode Manual");
		visca.SetFocusMode(1, FOCUS_MODE_MANUAL);
		wgPrintf("Focus mode %d", visca.GetFocusMode(1));
		break;
	case 'W':
		wgPrintf("Focus in");
		visca.SetFocusIn(1, 0);
		wgPrintf("Focus value %d", visca.GetFocus(1));
		break;
	case '2':
		wgPrintf("Focus out");
		visca.SetFocusOut(1, 0);
		wgPrintf("Focus value %d", visca.GetFocus(1));
		break;
	case 'C':
		wgPrintf("Focus to...");
		visca.SetFocus(1, 4096, false);
		wgPrintf("Focus value %d", visca.GetFocus(1));
		break;
	case 'D':
		wgPrintf("Focus to...");
		visca.SetFocus(1, 0x9FFF, false);
		wgPrintf("Focus value %d", visca.GetFocus(1));
		break;
	case 'E':
		wgPrintf("Focus to...");
		visca.SetFocusStop(1);
		wgPrintf("Focus value %d", visca.GetFocus(1));
		break;
	case 'V':
		visca.SetWBMode(1, WBMODE_AUTO);
		visca.GetWBMode(1);
		break;
	case 'F':
		visca.SetWBMode(1, WBMODE_INDOOR);
		visca.GetWBMode(1);
		break;
	case 'R':
		visca.SetWBMode(1, WBMODE_OUTDOOR);
		visca.GetWBMode(1);
		break;
	case '4':
		visca.SetWBMode(1, WBMODE_ONE_PUSH);
		visca.GetWBMode(1);
		break;
	case '3':
		visca.SetWBTrigger(1);
		visca.GetWBMode(1);
		break;
	case 'B':
		visca.SetAEMode(1, AEMODE_FULL_AUTO);
		visca.GetAEMode(1);
		break;
	case 'G':
		visca.SetAEMode(1, AEMODE_MANUAL);
		visca.GetAEMode(1);
		break;
	case 'T':
		visca.SetAEMode(1, AEMODE_SHUTTER);
		visca.GetAEMode(1);
		break;
	case '5':
		visca.SetAEMode(1, AEMODE_IRIS);
		visca.GetAEMode(1);
		break;
	case '6':
		visca.SetAEMode(1, AEMODE_BRIGHTNESS);
		visca.GetAEMode(1);
		break;
	case 'N':
		visca.SetBrightness(1, VALUE_UP);
		break;
	case 'H':
		visca.SetBrightness(1, VALUE_DOWN);
		break;
	case 'Y':
		visca.SetBrightness(1, VALUE_RESET);
		break;
	case 'M':
		visca.SetECMode(1, ECMODE_ON);
		visca.GetECMode(1);
		break;
	case 'J':
		visca.SetECMode(1, ECMODE_OFF);
		visca.GetECMode(1);
		break;
	case 'U':
		visca.SetShutter(1, 0);
		visca.GetShutter(1);
		break;
	case '7':
		visca.SetShutter(1, 0x1B);
		visca.GetShutter(1);
		break;
	case '8':
		visca.SetShutterStep(1, VALUE_RESET);
		visca.GetShutter(1);
		break;
	case 'K':
		visca.SetShutterStep(1, VALUE_UP);
		visca.GetShutter(1);
		break;
	case 'I':
		visca.SetShutterStep(1, VALUE_DOWN);
		visca.GetShutter(1);
		break;
	case 'L':
		visca.SetIrisStep(1, VALUE_UP);
		visca.GetIris(1);
		break;
	case 'O':
		visca.SetIrisStep(1, VALUE_DOWN);
		visca.GetIris(1);
		break;
	case '9':
		visca.SetIrisStep(1, VALUE_RESET);
		visca.GetIris(1);
		break;
	case '0':
		visca.SetGainStep(1, VALUE_RESET);
		visca.GetGain(1);
		break;
	case 'P':
		visca.SetGainStep(1, VALUE_DOWN);
		visca.GetGain(1);
		break;
	case ' ':
		visca.SetGainStep(1, VALUE_UP);
		visca.GetGain(1);
		break;
	case 190:
		visca.SetIris(1, 0);
		visca.GetIris(1);
		break;
	case 191:
		visca.SetIris(1, 0x11);
		visca.GetIris(1);
		break;
	case 186:
		visca.SetGain(1, 0);
		visca.GetGain(1);
		break;
	case 222:
		visca.SetGain(1, 7);
		visca.GetGain(1);
		break;
	case 112:
		visca.SetTime(1);
		break;
	case 113:
		visca.SetTimeDisplay(1, DISPLAY_OFF);
		break;
	case 114:
		visca.SetTimeDisplay(1, DISPLAY_TIME);
		break;
	case 115:
		visca.SetTimeDisplay(1, DISPLAY_DATE);
		break;
	case 116:
		visca.SetTimeDisplay(1, DISPLAY_DATE_TIME);
		break;
	default:
		break;
	}



	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
