// winprintf : Functions to print text onto a dialog window
//             Modified from Iris code - original author: paragano
// Copyright 1997 David Sarnoff Research Center
// All Rights Reserved
// Shop Order: 
// Author: 
//

#ifdef VERSION_VAR
#ifndef lint
static const char "rcsid = @# $Id: winprintf.cpp,v 1.1 1997/07/30 18:13:22 jeledath Exp $"
#endif /*lint*/
#endif /*VERSION_VAR */


#include "stdafx.h"
#include <windowsx.h>
#include "resource.h"
#include "debugwindow.h"
#include "winprintf.h"

static CDebugWindow *debugWin=NULL;

void wgCreateDebugWindow()
{
   debugWin = new CDebugWindow(); 
   
if (debugWin)
   {	
   	   debugWin->Create(IDD_DIALOG4, NULL);
   //debugWin->DoModal();
	   debugWin->ShowWindow(SW_SHOW);
   }
}

void wgDeleteDebugWindow()
{
   if (debugWin)
   {
	   delete debugWin;
	   debugWin = NULL;
   }
}

void wgPrintf(char *format, ...)
{
	if (!debugWin) return;
	if (!IsWindow(debugWin->m_hWnd)) return;

    va_list ap;
    char str[256];

    va_start(ap, format);
    vsprintf(str, format, ap);
    va_end(ap);

	int count = debugWin->m_listbox.GetCount();
	CString cstr;
	cstr.Format("%04d - %s", count+1, str); 

	if (!debugWin->bPaused)
	{
		debugWin->m_listbox.AddString(cstr);
		debugWin->m_listbox.SetCurSel(count);
	}
}
